## Ms Basic Connect Extensions V3 service

Ms Basic Connect Extensions V3 service — Support for the Ms Basic Connect Extensions V3 service.

## Functions

void | mbim_cell_info_serving_nr_array_free ()
void | mbim_cell_info_neighboring_nr_array_free ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_device_caps_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_v3_modem_configuration_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_modem_configuration_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_modem_configuration_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_v3_registration_parameters_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_v3_registration_parameters_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_registration_parameters_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_v3_base_stations_info_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_base_stations_info_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_v3_wake_reason_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_v3_wake_reason_response_parse ()

## Types and Values

| MbimCellInfoServingNr
typedef | MbimCellInfoServingNrArray
| MbimCellInfoNeighboringNr
typedef | MbimCellInfoNeighboringNrArray

## Description

This section implements support for requests, responses and notifications in the Ms Basic Connect Extensions V3 service.

## Functions

### mbim_cell_info_serving_nr_array_free ()

    void
    mbim_cell_info_serving_nr_array_free (MbimCellInfoServingNrArray *array);

Frees the memory allocated for the array of MbimCellInfoServingNr structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoServingNr structs. |

Since: 1.28

### mbim_cell_info_neighboring_nr_array_free ()

    void
    mbim_cell_info_neighboring_nr_array_free
                                   (MbimCellInfoNeighboringNrArray *array);

Frees the memory allocated for the array of MbimCellInfoNeighboringNr structs.

#### Parameters

array | a NULL terminated array of MbimCellInfoNeighboringNr structs. |

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_device_caps_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_device_caps_response_parse
                                   (const MbimMessage *message,
                                    MbimDeviceType *out_device_type,
                                    MbimCellularClass *out_cellular_class,
                                    MbimVoiceClass *out_voice_class,
                                    MbimSimClass *out_sim_class,
                                    MbimDataClassV3 *out_data_class,
                                    MbimSmsCaps *out_sms_caps,
                                    MbimCtrlCaps *out_control_caps,
                                    MbimDataSubclass *out_data_subclass,
                                    guint32 *out_max_sessions,
                                    guint32 *out_executor_index,
                                    guint32 *out_wcdma_band_class,
                                    guint32 *out_lte_band_class_count,
                                    guint16 **out_lte_band_class,
                                    guint32 *out_nr_band_class_count,
                                    guint16 **out_nr_band_class,
                                    gchar **out_custom_data_class,
                                    gchar **out_device_id,
                                    gchar **out_firmware_info,
                                    gchar **out_hardware_info,
                                    GError **error);

Parses and returns parameters of the 'Device Caps' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_device_type | return location for a MbimDeviceType, or `NULL` if the 'DeviceType' field is not needed. | [out][optional][transfer none]
out_cellular_class | return location for a MbimCellularClass, or `NULL` if the 'CellularClass' field is not needed. | [out][optional][transfer none]
out_voice_class | return location for a MbimVoiceClass, or `NULL` if the 'VoiceClass' field is not needed. | [out][optional][transfer none]
out_sim_class | return location for a MbimSimClass, or `NULL` if the 'SimClass' field is not needed. | [out][optional][transfer none]
out_data_class | return location for a MbimDataClassV3, or `NULL` if the 'DataClass' field is not needed. | [out][optional][transfer none]
out_sms_caps | return location for a MbimSmsCaps, or `NULL` if the 'SmsCaps' field is not needed. | [out][optional][transfer none]
out_control_caps | return location for a MbimCtrlCaps, or `NULL` if the 'ControlCaps' field is not needed. | [out][optional][transfer none]
out_data_subclass | return location for a guint64, or `NULL` if the 'DataSubclass' field is not needed. | [out][optional][transfer none]
out_max_sessions | return location for a guint32, or `NULL` if the 'MaxSessions' field is not needed. | [out][optional][transfer none]
out_executor_index | return location for a guint32, or `NULL` if the 'ExecutorIndex' field is not needed. | [out][optional][transfer none]
out_wcdma_band_class | return location for a guint32, or `NULL` if the 'WcdmaBandClass' field is not needed. | [out][optional][transfer none]
out_lte_band_class_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]
out_lte_band_class | return location for a newly allocated array of guint16 items, or `NULL` if the 'LteBandClass' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `g_free()`. | [out][optional][nullable][transfer full]
out_nr_band_class_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]
out_nr_band_class | return location for a newly allocated array of guint16 items, or `NULL` if the 'NrBandClass' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `g_free()`. | [out][optional][nullable][transfer full]
out_custom_data_class | return location for a newly allocated string, or `NULL` if the 'CustomDataClass' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_device_id | return location for a newly allocated string, or `NULL` if the 'DeviceId' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_firmware_info | return location for a newly allocated string, or `NULL` if the 'FirmwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_hardware_info | return location for a newly allocated string, or `NULL` if the 'HardwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_modem_configuration_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_v3_modem_configuration_query_new
                                   (GError **error);

Create a new request for the 'Modem Configuration' query command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_modem_configuration_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_modem_configuration_response_parse
                                   (const MbimMessage *message,
                                    MbimModemConfigurationStatus *out_configuration_status,
                                    gchar **out_configuration_name,
                                    GList **out_unnamed_ies,
                                    GError **error);

Parses and returns parameters of the 'Modem Configuration' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_configuration_status | return location for a MbimModemConfigurationStatus, or `NULL` if the 'ConfigurationStatus' field is not needed. | [out][optional][transfer none]
out_configuration_name | return location for a newly allocated string, or `NULL` if the 'ConfigurationName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_unnamed_ies | return location for a newly allocated list of MbimTlv items, or `NULL` if the 'UnnamedIes' field is not needed. Free the returned value with `g_list_free_full()` using `mbim_tlv_unref()` as GDestroyNotify. | [out][optional][element-type MbimTlv][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_modem_configuration_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_modem_configuration_notification_parse
                                   (const MbimMessage *message,
                                    MbimModemConfigurationStatus *out_modem_configuration_status,
                                    gchar **out_configuration_name,
                                    GList **out_unnamed_ies,
                                    GError **error);

Parses and returns parameters of the 'Modem Configuration' notification command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_modem_configuration_status | return location for a MbimModemConfigurationStatus, or `NULL` if the 'ModemConfigurationStatus' field is not needed. | [out][optional][transfer none]
out_configuration_name | return location for a newly allocated string, or `NULL` if the 'ConfigurationName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_unnamed_ies | return location for a newly allocated list of MbimTlv items, or `NULL` if the 'UnnamedIes' field is not needed. Free the returned value with `g_list_free_full()` using `mbim_tlv_unref()` as GDestroyNotify. | [out][optional][element-type MbimTlv][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_registration_parameters_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_v3_registration_parameters_query_new
                                   (GError **error);

Create a new request for the 'Registration Parameters' query command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_registration_parameters_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_v3_registration_parameters_set_new
                                   (MbimMicoMode mico_mode,
                                    MbimDrxCycle drx_cycle,
                                    MbimLadnInfo ladn_info,
                                    MbimDefaultPduActivationHint default_pdu_activation_hint,
                                    gboolean re_register_if_nedeed,
                                    const GList *unnamed_ies,
                                    GError **error);

Create a new request for the 'Registration Parameters' set command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

mico_mode | the 'MicoMode' field, given as a MbimMicoMode. | [in]
drx_cycle | the 'DrxCycle' field, given as a MbimDrxCycle. | [in]
ladn_info | the 'LadnInfo' field, given as a MbimLadnInfo. | [in]
default_pdu_activation_hint | the 'DefaultPduActivationHint' field, given as a MbimDefaultPduActivationHint. | [in]
re_register_if_nedeed | the 'ReRegisterIfNedeed' field, given as a gboolean. | [in]
unnamed_ies | the 'UnnamedIes' field, given as a list of # items. | [in][element-type MbimTlv][transfer none]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_registration_parameters_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_registration_parameters_response_parse
                                   (const MbimMessage *message,
                                    MbimMicoMode *out_mico_mode,
                                    MbimDrxCycle *out_drx_cycle,
                                    MbimLadnInfo *out_ladn_info,
                                    MbimDefaultPduActivationHint *out_default_pdu_activation_hint,
                                    gboolean *out_re_register_if_nedeed,
                                    GList **out_unnamed_ies,
                                    GError **error);

Parses and returns parameters of the 'Registration Parameters' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_mico_mode | return location for a MbimMicoMode, or `NULL` if the 'MicoMode' field is not needed. | [out][optional][transfer none]
out_drx_cycle | return location for a MbimDrxCycle, or `NULL` if the 'DrxCycle' field is not needed. | [out][optional][transfer none]
out_ladn_info | return location for a MbimLadnInfo, or `NULL` if the 'LadnInfo' field is not needed. | [out][optional][transfer none]
out_default_pdu_activation_hint | return location for a MbimDefaultPduActivationHint, or `NULL` if the 'DefaultPduActivationHint' field is not needed. | [out][optional][transfer none]
out_re_register_if_nedeed | return location for a gboolean, or `NULL` if the 'ReRegisterIfNedeed' field is not needed. | [out][optional][transfer none]
out_unnamed_ies | return location for a newly allocated list of MbimTlv items, or `NULL` if the 'UnnamedIes' field is not needed. Free the returned value with `g_list_free_full()` using `mbim_tlv_unref()` as GDestroyNotify. | [out][optional][element-type MbimTlv][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_response_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimNwError *out_nw_error,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_nw_error | return location for a MbimNwError, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_lte_attach_info_notification_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimNwError *out_nw_error,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' notification command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_nw_error | return location for a MbimNwError, or `NULL` if the 'NwError' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_base_stations_info_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_v3_base_stations_info_query_new
                                   (guint32 max_gsm_count,
                                    guint32 max_umts_count,
                                    guint32 max_tdscdma_count,
                                    guint32 max_lte_count,
                                    guint32 max_cdma_count,
                                    guint32 max_nr_count,
                                    GError **error);

Create a new request for the 'Base Stations Info' query command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

max_gsm_count | the 'MaxGsmCount' field, given as a guint32. | [in]
max_umts_count | the 'MaxUmtsCount' field, given as a guint32. | [in]
max_tdscdma_count | the 'MaxTdscdmaCount' field, given as a guint32. | [in]
max_lte_count | the 'MaxLteCount' field, given as a guint32. | [in]
max_cdma_count | the 'MaxCdmaCount' field, given as a guint32. | [in]
max_nr_count | the 'MaxNrCount' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_base_stations_info_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_base_stations_info_response_parse
                                   (const MbimMessage *message,
                                    MbimDataClassV3 *out_system_type,
                                    MbimDataSubclass *out_system_sub_type,
                                    MbimCellInfoServingGsm **out_gsm_serving_cell,
                                    MbimCellInfoServingUmts **out_umts_serving_cell,
                                    MbimCellInfoServingTdscdma **out_tdscdma_serving_cell,
                                    MbimCellInfoServingLte **out_lte_serving_cell,
                                    guint32 *out_gsm_neighboring_cells_count,
                                    MbimCellInfoNeighboringGsmArray **out_gsm_neighboring_cells,
                                    guint32 *out_umts_neighboring_cells_count,
                                    MbimCellInfoNeighboringUmtsArray **out_umts_neighboring_cells,
                                    guint32 *out_tdscdma_neighboring_cells_count,
                                    MbimCellInfoNeighboringTdscdmaArray **out_tdscdma_neighboring_cells,
                                    guint32 *out_lte_neighboring_cells_count,
                                    MbimCellInfoNeighboringLteArray **out_lte_neighboring_cells,
                                    guint32 *out_cdma_cells_count,
                                    MbimCellInfoCdmaArray **out_cdma_cells,
                                    guint32 *out_nr_serving_cells_count,
                                    MbimCellInfoServingNrArray **out_nr_serving_cells,
                                    guint32 *out_nr_neighbor_cells_count,
                                    MbimCellInfoNeighboringNrArray **out_nr_neighbor_cells,
                                    GError **error);

Parses and returns parameters of the 'Base Stations Info' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_system_type | return location for a MbimDataClassV3, or `NULL` if the 'SystemType' field is not needed. | [out][optional][transfer none]
out_system_sub_type | return location for a MbimDataSubclass, or `NULL` if the 'SystemSubType' field is not needed. | [out][optional][transfer none]
out_gsm_serving_cell | return location for a newly allocated MbimCellInfoServingGsm, or `NULL` if the 'GsmServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_gsm_free()`. | [out][optional][nullable][transfer full]
out_umts_serving_cell | return location for a newly allocated MbimCellInfoServingUmts, or `NULL` if the 'UmtsServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_umts_free()`. | [out][optional][nullable][transfer full]
out_tdscdma_serving_cell | return location for a newly allocated MbimCellInfoServingTdscdma, or `NULL` if the 'TdscdmaServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_tdscdma_free()`. | [out][optional][nullable][transfer full]
out_lte_serving_cell | return location for a newly allocated MbimCellInfoServingLte, or `NULL` if the 'LteServingCell' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_lte_free()`. | [out][optional][nullable][transfer full]
out_gsm_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_gsm_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringGsm items, or `NULL` if the 'GsmNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_gsm_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringGsm]

out_umts_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_umts_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringUmts items, or `NULL` if the 'UmtsNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_umts_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringUmts]

out_tdscdma_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_tdscdma_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringTdscdma items, or `NULL` if the 'TdscdmaNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_tdscdma_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringTdscdma]

out_lte_neighboring_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_lte_neighboring_cells

return location for a newly allocated array of MbimCellInfoNeighboringLte items, or `NULL` if the 'LteNeighboringCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_lte_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringLte]

out_cdma_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_cdma_cells

return location for a newly allocated array of MbimCellInfoCdma items, or `NULL` if the 'CdmaCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_cdma_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoCdma]

out_nr_serving_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_nr_serving_cells

return location for a newly allocated array of MbimCellInfoServingNr items, or `NULL` if the 'NrServingCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_serving_nr_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoServingNr]

out_nr_neighbor_cells_count | return location for a guint32, or `NULL` if the field is not needed. | [out][optional][transfer none]

out_nr_neighbor_cells

return location for a newly allocated array of MbimCellInfoNeighboringNr items, or `NULL` if the 'NrNeighborCells' field is not needed. The availability of this field is not always guaranteed, and therefore `NULL` may be given as a valid output. Free the returned value with `mbim_cell_info_neighboring_nr_array_free()`.

[out][optional][nullable][transfer full][array zero-terminated=1][element-type MbimCellInfoNeighboringNr]

error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_wake_reason_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_v3_wake_reason_query_new
                                   (GError **error);

Create a new request for the 'Wake Reason' query command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.28

### mbim_message_ms_basic_connect_extensions_v3_wake_reason_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_v3_wake_reason_response_parse
                                   (const MbimMessage *message,
                                    MbimWakeType *out_wake_type,
                                    guint32 *out_session_id,
                                    MbimTlv **out_wake_tlv,
                                    GError **error);

Parses and returns parameters of the 'Wake Reason' response command in the 'Ms Basic Connect Extensions V3' service.

#### Parameters

message | the MbimMessage. |
out_wake_type | return location for a MbimWakeType, or `NULL` if the 'WakeType' field is not needed. | [out][optional][transfer none]
out_session_id | return location for a guint32, or `NULL` if the 'SessionId' field is not needed. | [out][optional][transfer none]
out_wake_tlv | return location for a newly allocated MbimTlv, or `NULL` if the 'WakeTlv' field is not needed. Free the returned value with `mbim_tlv_unref()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.28

## Types and Values

### MbimCellInfoServingNr

    typedef struct {
        gchar *provider_id;
        guint64 nci;
        guint32 physical_cell_id;
        guint32 nrarfcn;
        guint32 tac;
        guint32 rsrp;
        guint32 rsrq;
        guint32 sinr;
        guint64 timing_advance;
    } MbimCellInfoServingNr;

A MbimCellInfoServingNr element.

#### Members

gchar *`provider_id`; | a string. |
guint64 `nci`; | a guint64. |
guint32 `physical_cell_id`; | a guint32. |
guint32 `nrarfcn`; | a guint32. |
guint32 `tac`; | a guint32. |
guint32 `rsrp`; | a guint32. |
guint32 `rsrq`; | a guint32. |
guint32 `sinr`; | a guint32. |
guint64 `timing_advance`; | a guint64. |

Since: 1.28

### MbimCellInfoServingNrArray

    typedef MbimCellInfoServingNr *MbimCellInfoServingNrArray;

A NULL-terminated array of MbimCellInfoServingNr elements.

Since: 1.28

### MbimCellInfoNeighboringNr

    typedef struct {
        guint32 system_sub_type;
        gchar *provider_id;
        gchar *cell_id;
        guint32 physical_cell_id;
        guint32 tac;
        guint32 rsrp;
        guint32 rsrq;
        guint32 sinr;
    } MbimCellInfoNeighboringNr;

A MbimCellInfoNeighboringNr element.

#### Members

guint32 `system_sub_type`; | a MbimDataSubclass given as a guint32. |
gchar *`provider_id`; | a string. |
gchar *`cell_id`; | a string. |
guint32 `physical_cell_id`; | a guint32. |
guint32 `tac`; | a guint32. |
guint32 `rsrp`; | a guint32. |
guint32 `rsrq`; | a guint32. |
guint32 `sinr`; | a guint32. |

Since: 1.28

### MbimCellInfoNeighboringNrArray

    typedef MbimCellInfoNeighboringNr *MbimCellInfoNeighboringNrArray;

A NULL-terminated array of MbimCellInfoNeighboringNr elements.

Since: 1.28